#BEGIN COPYRIGHT
#*************************************************************************
#
# Licensed Materials - Property of IBM
# 5725-C94, 5725-C95, 5725-C96
# (C) Copyright IBM Corporation 2012. All Rights Reserved.
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#
#*************************************************************************
#END COPYRIGHT

from java.lang import System, String
import sys


print "*************************************************************************************"
print "start: init"
print ""

fileSeparator = System.getProperty("file.separator");
configUtilsScript = System.getProperty("was.install.root") + fileSeparator + "util" + fileSeparator + "config" + fileSeparator + "admin" + fileSeparator + "configUtils.py"
print "load configuration utils from ", configUtilsScript
execfile(configUtilsScript);

authAliases=["BPMUser_Auth_Alias","BPMAuthor_Auth_Alias","BPMWebservice_Auth_Alias","BPMAdmin_Auth_Alias"]

internalUsers=["tw_admin", "tw_author", "tw_user", "tw_webservice", "tw_portal_admin", "tw_runtime_server", "bpmAuthor"]

wasRepositoryRoot = System.getProperty("was.repository.root")
print "was.repository.root=" + wasRepositoryRoot

userUniquePostfix = ",o=defaultWIMFileBasedRealm"

from com.lombardisoftware.ant import LoadAuthAliasUserIDPasswordTask
from org.apache.tools.ant import Project


print ""
print "end: init"


def createInternalUsers():
    password = getPasswordFromAuthAliases("BPMAdmin_Auth_Alias")
    for userId in internalUsers:
        print "Create internal user for " + userId
        user = AdminTask.searchUsers(['-uid', userId])
        if(user==""):
            print "Can not find user: " + userId + ", create it at the user registry."
            AdminTask.createUser(['-uid', userId, '-password', password, '-confirmPassword', password, '-cn', userId, '-sn', userId])
        else:
            print "Find user " + user
            
def resetPassword():
    print "Reset password"
    for item in authAliases:
        print item
        userId = getUserIdFromAuthAliases(item)
        password = getPasswordFromAuthAliases(item)
        try:
            AdminTask.updateUser (['-uniqueName', 'uid=' + userId + userUniquePostfix, '-password', password, '-confirmPassword', password])
        except:
            print "user:" + 'uid=' + userId + userUniquePostfix + " do not exist at the file user registry."
      
    AdminConfig.save()            
                

        
#endDef

def getPasswordFromAuthAliases(aliasName):
    aliasHelper = LoadAuthAliasUserIDPasswordTask()
    project = Project()
    aliasHelper.setProject(project)
    aliasHelper.setAuthAliasName(aliasName)
    aliasHelper.setPasswordProperty("password")
    aliasHelper.execute()
    password = aliasHelper.getProject().getProperty("password")
    print "password=" + "******"
    return password
#endDef

def getUserIdFromAuthAliases(aliasName):
    aliasHelper = LoadAuthAliasUserIDPasswordTask()
    project = Project()
    aliasHelper.setProject(project)
    aliasHelper.setAuthAliasName(aliasName)
    aliasHelper.setUserIDProperty("userid")
    aliasHelper.execute()
    userid = aliasHelper.getProject().getProperty("userid")
    print "userid=" + userid
    return userid
#endDef

def syncNodes():    
    print "Start sync nodes..."
    nodeAgentList = getObjectArray(AdminConfig.list("NodeAgent"))

    cellId = getObjectArray(AdminConfig.list("Cell"))

    nodeList = getObjectArray(AdminConfig.list('Node',cellId[0]))  
    nodenameList = []
    for node in nodeList:
        print node
        nodename = AdminConfig.showAttribute(node,'name')
        print nodename
        nodenameList.append(nodename)
    print nodenameList

    stoppedNodeList = []
    startedNodeList = []    
    
    for nodename in nodenameList:
        nodeAgentMbean = AdminControl.queryNames('type=NodeAgent,node=' + nodename + ',*')
        if(nodeAgentMbean == ""):
            # remove the dmgr node
            stoppedNodeList.append(nodename)
        else:
            startedNodeList.append(nodename)    

    for nodename in startedNodeList:
        try:
            nodeSyncId = AdminControl.completeObjectName('type=NodeSync,node=' + nodename + ',*')
            print "nodeSyncId=" + nodeSyncId
            AdminControl.invoke(nodeSyncId, 'sync')
            print "Sync node: " + nodename + " succeed."
        except:
            print "failed to sync node: " + nodename
    
    print "End sync nodes."
#endDef


#*******************************************************************************************************
# main
#*******************************************************************************************************
print "*************************************************************************************"
print "Start: reset the password at the file user registry"
print ""
print ""

resetPassword()
syncNodes()

print ""
print "End: reset the password at the file user registry"
print "*************************************************************************************"

